var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var create_exports = {};
__export(create_exports, {
  default: () => create_default
});
module.exports = __toCommonJS(create_exports);
var import_constants = require("../constants");
var import_utils = require("../utils");
var create_default = {
  async run(node, input, processor) {
    const { collection, params: { appends = [], ...params } = {} } = node.config;
    const { repository, model } = node.constructor.database.getCollection(collection);
    const options = processor.getParsedValue(params, node.id);
    const created = await repository.create({
      ...options,
      context: {
        executionId: processor.execution.id
      },
      transaction: processor.transaction
    });
    let result = created;
    if (created && appends.length) {
      const includeFields = appends.reduce((set, field) => {
        set.add(field.split(".")[0]);
        set.add(field);
        return set;
      }, /* @__PURE__ */ new Set());
      result = await repository.findOne({
        filterByTk: created[model.primaryKeyAttribute],
        appends: Array.from(includeFields),
        transaction: processor.transaction
      });
    }
    return {
      // NOTE: get() for non-proxied instance (#380)
      result: (0, import_utils.toJSON)(result),
      status: import_constants.JOB_STATUS.RESOLVED
    };
  }
};
